#!/bin/sh
# QmailAlizer Installer 0.4 written by hip0
# Under GPL 2.0 and above.
# for problems contact me at: hipodilski@openvms-rocks.com

temp_dir="template";
temp_ind="$temp_dir/index.php";
temp_dom="$temp_dir/domain.php";
qm_conf="qmailalizer.conf";

trap 'echo -e "\nOkay. Maybe the next time :]"; exit 1;' INT;
clear;
echo -e "QmailAlizer Installer 0.4 by hip0. Greetings to Wolfgang for the great work.";
echo "Enter location for the document root of qmailalizer";
echo -e "For example /var/www/qmailalizer\n\n";
echo -n "Directory Location:";
read dir_loc;

if [ -z "$dir_loc" ]; then
echo "Empty dir specified";
exit 1;
fi

if [ ! -d "$dir_loc" ]; then

echo -n "$dir_loc doesn't exist. Create it now [Y/N]:";
read yes_no;

if [ ${yes_no} = "Y" ] || [ ${yes_no} = "y" ]; then
mkdir -p "${dir_loc}";
else
echo "Okay create it yourself. Exiting !";
exit 1;
fi

fi

if [ -f "configure" ]; then
echo "Configuring ...";
./configure "$@"
fi

if [ -f "Makefile" ]; then
echo -e "Now Making the shit.\n";
make 
echo -e "Now installing ...\n";
make install
fi

cat /dev/null > ${temp_dir}/${qm_conf}.temp;
cat /dev/null > ${temp_ind}.temp;
cat /dev/null > ${temp_dom}.temp;

if [ -f ${qm_conf} ]; then

while read line
    do
	echo "$line" | sed -e "s#changeme_#${dir_loc}/#g" >> ${temp_dir}/${qm_conf}.temp;
    done < "$qm_conf";

fi

if [ -f ${temp_ind} ]; then

while read line1
    do
        echo "$line1" | sed -e "s#changeme_#${dir_loc}/#g" >> ${temp_ind}.temp;
    done < "${temp_ind}";

fi


if [ -f ${temp_dom} ]; then

while read line2
    do
	echo "$line2" | sed -e "s#changeme_#${dir_loc}/#g" >> ${temp_dom}.temp;
done < "${temp_dom}";


fi

echo "Copying templates to specified ${dir_loc}";

if [ -d "${temp_dir}" ] && [ -d "${dir_loc}" ]; then
cp -f ${temp_dir}/index.php.temp ${dir_loc}/index.php;
cp -f ${temp_dir}/domain.php.temp ${dir_loc}/domain.php;
cp -f ${temp_dir}/*.{xsl,png} ${dir_loc}/;
else

echo "Missing templates dir. or doc_root";
exit 1;

fi


echo "Copying qmailaizer.conf to /etc";

if [ -f "${qm_conf}" ]; then
/bin/cp -f ${temp_dir}/${qm_conf}.temp /etc/${qm_conf};

else

echo "Missing ${qm_conf}. Exiting!";
exit 1;

fi

if [ -d ${temp_dir} ]; then
rm -f ${temp_dir}/*.temp;
fi

echo "All Operations completed successfully! Your install should be okay now. Greetings !!!";
echo "Run qmailalizer to generate the log statistics for your mail server."
echo "Don't forget to set your proper permissions on ${dir_loc}";
exit 0;
